using FitConnect.Models.v1.Api;

namespace FitConnect;

public class SecurityEventException : Exception {
    public string Title { get; }
    public string Detail { get; }

    public SecurityEventException(Problems problem, Exception? innerException = null) : base(
        $"{problem.title}: {problem.detail}", innerException) {
        Title = problem.title;
        Detail = problem.detail;
    }

    public SecurityEventException(Problems[] problem, Exception? innerException = null) : base(
        $"{problem[0].title}: {problem[0].detail}", innerException) {
        Title = problem.Select(p => p.title).Aggregate((a, b) => a + "\r\n" + b);
        Detail = problem.Select(p => p.detail).Aggregate((a, b) => a + "\r\n" + b);
    }

    public SecurityEventException(string title, string detail, Exception? innerException = null) :
        base(
            $"{title}: {detail}", innerException) {
        Title = title;
        Detail = detail;
    }
}
